diff --git a/src/tui/tools/bb-dolt-read.ts b/src/tui/tools/bb-dolt-read.ts
new file mode 100644
index 0000000..40218e0
--- /dev/null
+++ b/src/tui/tools/bb-dolt-read.ts
@@ -0,0 +1,50 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { readIssuesFromDisk } from '../../lib/read-issues';
+
+export function createDoltReadTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_dolt_read_issues',
+    label: 'Read Project Tasks',
+    description: 'Read the current project tasks (BeadBoard issues) from the Dolt backend. Always use this to check task state before acting.',
+    parameters: Type.Object({
+      limit: Type.Optional(Type.Number({ description: 'Max number of tasks to return' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const issues = await readIssuesFromDisk({ projectRoot });
+        const sliced = params.limit ? issues.slice(0, params.limit) : issues;
+        
+        // Strip out some heavy metadata to keep context clean
+        const compactIssues = sliced.map((i) => ({
+          id: i.id,
+          title: i.title,
+          status: i.status,
+          priority: i.priority,
+          issue_type: i.issue_type,
+          assignee: i.assignee,
+        }));
+
+        return {
+          content: [
+            {
+              type: 'text',
+              text: JSON.stringify(compactIssues, null, 2),
+            },
+          ],
+          details: {
+            total: issues.length,
+            returned: compactIssues.length,
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to read tasks: ${message}` }],
+          isError: true,
+          details: {},
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-list-agents.ts b/src/tui/tools/bb-list-agents.ts
new file mode 100644
index 0000000..dbdb396
--- /dev/null
+++ b/src/tui/tools/bb-list-agents.ts
@@ -0,0 +1,45 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { getAgentTypes } from '../../lib/server/beads-fs';
+
+export function createListAgentsTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_list_agents',
+    label: 'List Agent Types',
+    description: 'List all available agent types. Returns id, name, description, capabilities, and color for each. Agent types are the kinds of workers the orchestrator can spawn.',
+    parameters: Type.Object({}),
+    async execute() {
+      try {
+        const agentTypes = await getAgentTypes(projectRoot);
+
+        const summary = agentTypes.map(a =>
+          `- ${a.name} (${a.id}): ${a.description}\n  Capabilities: ${a.capabilities.join(', ')}`
+        ).join('\n\n');
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Found ${agentTypes.length} agent types:\n\n${summary}`,
+          }],
+          details: {
+            agentTypes: agentTypes.map(a => ({
+              id: a.id,
+              name: a.name,
+              description: a.description,
+              capabilities: a.capabilities,
+              color: a.color,
+              isBuiltIn: a.isBuiltIn,
+            })),
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to list agent types: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-list-archetypes.ts b/src/tui/tools/bb-list-archetypes.ts
new file mode 100644
index 0000000..086173b
--- /dev/null
+++ b/src/tui/tools/bb-list-archetypes.ts
@@ -0,0 +1,45 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { getArchetypes } from '../../lib/server/beads-fs';
+
+export function createListArchetypesTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_list_archetypes',
+    label: 'List Archetypes',
+    description: 'List all available archetypes. Returns id, name, description, capabilities, and color for each archetype.',
+    parameters: Type.Object({}),
+    async execute() {
+      try {
+        const archetypes = await getArchetypes();
+
+        const summary = archetypes.map(a =>
+          `- ${a.name} (${a.id}): ${a.description}\n  Capabilities: ${a.capabilities.join(', ')}`
+        ).join('\n\n');
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Found ${archetypes.length} archetypes:\n\n${summary}`,
+          }],
+          details: {
+            archetypes: archetypes.map(a => ({
+              id: a.id,
+              name: a.name,
+              description: a.description,
+              capabilities: a.capabilities,
+              color: a.color,
+              isBuiltIn: a.isBuiltIn,
+            })),
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to list archetypes: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-list-templates.ts b/src/tui/tools/bb-list-templates.ts
new file mode 100644
index 0000000..be9aff4
--- /dev/null
+++ b/src/tui/tools/bb-list-templates.ts
@@ -0,0 +1,45 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { getTemplates } from '../../lib/server/beads-fs';
+
+export function createListTemplatesTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_list_templates',
+    label: 'List Swarm Templates',
+    description: 'List all available swarm templates. Returns team composition showing which archetypes and how many workers of each.',
+    parameters: Type.Object({}),
+    async execute() {
+      try {
+        const templates = await getTemplates();
+
+        const summary = templates.map(t => {
+          const teamDesc = t.team.map(m => `${m.count}x ${m.agentTypeId}`).join(', ');
+          return `- ${t.name} (${t.id}): ${t.description}\n  Team: ${teamDesc}`;
+        }).join('\n\n');
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Found ${templates.length} swarm templates:\n\n${summary}`,
+          }],
+          details: {
+            templates: templates.map(t => ({
+              id: t.id,
+              name: t.name,
+              description: t.description,
+              team: t.team,
+              isBuiltIn: t.isBuiltIn,
+            })),
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to list templates: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-mailbox.ts b/src/tui/tools/bb-mailbox.ts
new file mode 100644
index 0000000..ecd18aa
--- /dev/null
+++ b/src/tui/tools/bb-mailbox.ts
@@ -0,0 +1,105 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { inboxAgentMessages, sendAgentMessage, ackAgentMessage } from '../../lib/agent-mail';
+
+export function createMailboxTools(): ToolDefinition[] {
+  return [
+    {
+      name: 'bb_read_inbox',
+      label: 'Read Mailbox',
+      description: 'Read incoming coordination messages (HANDOFF, BLOCKED, INFO) for an agent.',
+      parameters: Type.Object({
+        agent: Type.String({ description: 'The agent ID to read messages for (usually yourself)' }),
+        state: Type.Optional(Type.String({ description: 'Filter by state: unread, read, acked' })),
+        limit: Type.Optional(Type.Number({ description: 'Max messages to return' })),
+      }),
+      async execute(_toolCallId, params: any) {
+        try {
+          const result = await inboxAgentMessages({
+            agent: params.agent,
+            state: params.state,
+            limit: params.limit,
+          });
+          
+          if (!result.ok) {
+            return { content: [{ type: 'text', text: `Failed: ${result.error?.message}` }], isError: true, details: {} };
+          }
+
+          return {
+            content: [{ type: 'text', text: JSON.stringify(result.data, null, 2) }],
+            details: {},
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return { content: [{ type: 'text', text: `Error: ${message}` }], isError: true, details: {} };
+        }
+      },
+    },
+    {
+      name: 'bb_send_message',
+      label: 'Send Message',
+      description: 'Send a coordination message to another agent or broadcast. Use for HANDOFF or reporting BLOCKED states.',
+      parameters: Type.Object({
+        from: Type.String({ description: 'Your agent ID' }),
+        to: Type.String({ description: 'Recipient agent ID (or broadcast)' }),
+        bead: Type.String({ description: 'The task/bead ID this relates to' }),
+        category: Type.String({ description: 'One of: HANDOFF, BLOCKED, DECISION, INFO' }),
+        subject: Type.String({ description: 'Short summary' }),
+        body: Type.String({ description: 'Detailed message body' }),
+      }),
+      async execute(_toolCallId, params: any) {
+        try {
+          const result = await sendAgentMessage({
+            from: params.from,
+            to: params.to,
+            bead: params.bead,
+            category: params.category,
+            subject: params.subject,
+            body: params.body,
+          });
+
+          if (!result.ok) {
+            return { content: [{ type: 'text', text: `Failed: ${result.error?.message}` }], isError: true, details: {} };
+          }
+
+          return {
+            content: [{ type: 'text', text: `Message sent successfully. ID: ${result.data?.message_id}` }],
+            details: {},
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return { content: [{ type: 'text', text: `Error: ${message}` }], isError: true, details: {} };
+        }
+      },
+    },
+    {
+      name: 'bb_ack_message',
+      label: 'Acknowledge Message',
+      description: 'Acknowledge a required message (like a HANDOFF or BLOCKED notification) to signal you have received it.',
+      parameters: Type.Object({
+        agent: Type.String({ description: 'Your agent ID' }),
+        messageId: Type.String({ description: 'The ID of the message to acknowledge' }),
+      }),
+      async execute(_toolCallId, params: any) {
+        try {
+          const result = await ackAgentMessage({
+            agent: params.agent,
+            message: params.messageId,
+          });
+
+          if (!result.ok) {
+            return { content: [{ type: 'text', text: `Failed: ${result.error?.message}` }], isError: true, details: {} };
+          }
+
+          return {
+            content: [{ type: 'text', text: `Message ${params.messageId} acknowledged successfully.` }],
+            details: {},
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return { content: [{ type: 'text', text: `Error: ${message}` }], isError: true, details: {} };
+        }
+      },
+    }
+  ];
+}
diff --git a/src/tui/tools/bb-presence.ts b/src/tui/tools/bb-presence.ts
new file mode 100644
index 0000000..b9a7f01
--- /dev/null
+++ b/src/tui/tools/bb-presence.ts
@@ -0,0 +1,42 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { registerAgent, extendActivityLease } from '../../lib/agent-registry';
+
+export function createPresenceTools(): ToolDefinition[] {
+  return [
+    {
+      name: 'bb_update_presence',
+      label: 'Update Presence',
+      description: 'Register or extend your presence lease in the BeadBoard agent registry so the frontend knows you are alive.',
+      parameters: Type.Object({
+        agent: Type.String({ description: 'Your agent ID (e.g., orchestrator)' }),
+        role: Type.String({ description: 'Your role (e.g., orchestrator, worker)' }),
+        display: Type.Optional(Type.String({ description: 'Friendly display name' })),
+      }),
+      async execute(_toolCallId, params: any) {
+        try {
+          // Attempt to register/update
+          const result = await registerAgent({
+            name: params.agent,
+            role: params.role,
+            display: params.display,
+            forceUpdate: true,
+          });
+
+          if (!result.ok) {
+            // Fallback to just lease extension if register fails or acts weird
+            await extendActivityLease({ agent: params.agent });
+          }
+
+          return {
+            content: [{ type: 'text', text: `Presence updated for ${params.agent}.` }],
+            details: {},
+          };
+        } catch (error) {
+          const message = error instanceof Error ? error.message : String(error);
+          return { content: [{ type: 'text', text: `Error: ${message}` }], isError: true, details: {} };
+        }
+      },
+    },
+  ];
+}
diff --git a/src/tui/tools/bb-spawn-template.ts b/src/tui/tools/bb-spawn-template.ts
new file mode 100644
index 0000000..6828da9
--- /dev/null
+++ b/src/tui/tools/bb-spawn-template.ts
@@ -0,0 +1,167 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { getTemplates, getAgentTypes } from '../../lib/server/beads-fs';
+import { workerSessionManager } from '../../lib/worker-session-manager';
+
+/**
+ * Generate a task ID from natural language.
+ */
+function generateTaskId(description: string): string {
+  const slug = description
+    .toLowerCase()
+    .slice(0, 40)
+    .replace(/[^a-z0-9]+/g, '-')
+    .replace(/^-|-$/g, '');
+  
+  const ts = Date.now().toString(36).slice(-4);
+  return `${slug}-${ts}`;
+}
+
+/**
+ * Auto-select template based on task description keywords.
+ */
+function autoSelectTemplate(description: string): string {
+  const desc = description.toLowerCase();
+  
+  if (desc.includes('bug') || desc.includes('fix') || desc.includes('error') || desc.includes('fail')) {
+    return 'bug-fix';
+  }
+  if (desc.includes('review') || desc.includes('audit')) {
+    return 'code-review';
+  }
+  if (desc.includes('investigate') || desc.includes('research') || desc.includes('analyze')) {
+    return 'investigation';
+  }
+  if (desc.includes('refactor') || desc.includes('clean') || desc.includes('improve')) {
+    return 'refactor';
+  }
+  if (desc.includes('deploy') || desc.includes('release') || desc.includes('ship')) {
+    return 'release';
+  }
+  if (desc.includes('new project') || desc.includes('from scratch') || desc.includes('greenfield')) {
+    return 'greenfield';
+  }
+  // Default for features and general work
+  return 'feature-dev';
+}
+
+export function createSpawnTemplateTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_spawn_team',
+    label: 'Spawn Agent Team',
+    description: `Spawn a team of agents using a template. Use for larger tasks that need multiple specialists.
+
+Examples:
+- "Build a user authentication system"
+- "Investigate and fix the payment processing bug"
+- "Review and improve the API layer"
+
+Available templates:
+- feature-dev: Architect + 2 Engineers + Reviewer + Tester (new features)
+- bug-fix: Investigator + Engineer + Tester (debugging)
+- code-review: Reviewer + Engineer (code review)
+- investigation: Investigator + Tester (research/analysis)
+- refactor: Architect + 2 Engineers + Tester (code improvement)
+- release: Tester + Reviewer + Shipper (deployment)
+- greenfield: Full team for new projects
+- full-squad: All agent types for complex work`,
+    parameters: Type.Object({
+      description: Type.String({ 
+        description: 'What you want the team to accomplish. Be specific about scope and goals.' 
+      }),
+      template: Type.Optional(Type.String({ 
+        description: 'Template name. If not provided, one will be selected based on your description.' 
+      })),
+    }),
+    async execute(_toolCallId: string, params: unknown): Promise<any> {
+      const { description, template } = params as {
+        description: string;
+        template?: string;
+      };
+
+      if (!description || typeof description !== 'string') {
+        return {
+          content: [{ type: 'text', text: 'Please describe what you want the team to accomplish.' }],
+          isError: true,
+        };
+      }
+
+      // Auto-select template if not provided
+      const templateId = template || autoSelectTemplate(description);
+
+      // Load template
+      const templates = await getTemplates(projectRoot);
+      const selectedTemplate = templates.find(t => t.id === templateId);
+      
+      if (!selectedTemplate) {
+        return {
+          content: [{ 
+            type: 'text', 
+            text: `Template "${templateId}" not found. Available: ${templates.map(t => t.id).join(', ')}` 
+          }],
+          isError: true,
+        };
+      }
+
+      // Load agent types
+      const agentTypes = await getAgentTypes(projectRoot);
+      const agentTypeMap = new Map(agentTypes.map(a => [a.id, a]));
+
+      // Generate task ID
+      const taskId = generateTaskId(description);
+
+      // Spawn workers for each team member
+      const spawned: Array<{ id: string; displayName?: string; agentTypeId: string }> = [];
+      const spawnErrors: string[] = [];
+      
+      for (const member of selectedTemplate.team) {
+        const agentType = agentTypeMap.get(member.agentTypeId);
+        if (!agentType) {
+          spawnErrors.push(`Unknown agent type: ${member.agentTypeId}`);
+          continue;
+        }
+        
+        for (let i = 0; i < member.count; i++) {
+          try {
+            const worker = await workerSessionManager.spawnWorker({
+              projectRoot,
+              taskId: `${taskId}-${member.agentTypeId}-${i + 1}`,
+              taskContext: description,
+              agentType: member.agentTypeId,
+            });
+            spawned.push({
+              id: worker.id,
+              displayName: worker.displayName,
+              agentTypeId: member.agentTypeId,
+            });
+          } catch (error) {
+            spawnErrors.push(`Failed to spawn ${member.agentTypeId}: ${error instanceof Error ? error.message : String(error)}`);
+          }
+        }
+      }
+
+      // Build result
+      const teamDesc = selectedTemplate.team.map(m => `${m.count}×${m.agentTypeId}`).join(' + ');
+      const names = spawned.map(s => s.displayName).filter(Boolean).join(', ');
+      
+      let message = `✓ Spawned ${spawned.length} agents using "${selectedTemplate.name}"\n\n`;
+      message += `Team: ${teamDesc}\n`;
+      message += `Active: ${names}\n\n`;
+      message += `Goal: "${description.slice(0, 80)}${description.length > 80 ? '...' : ''}"`;
+      
+      if (spawnErrors.length > 0) {
+        message += `\n\nErrors:\n${spawnErrors.map(e => `- ${e}`).join('\n')}`;
+      }
+
+      return {
+        content: [{ type: 'text', text: message }],
+        details: { 
+          template: { id: selectedTemplate.id, name: selectedTemplate.name },
+          taskId,
+          spawned: spawned.map(s => ({ id: s.id, displayName: s.displayName })),
+          errors: spawnErrors.length > 0 ? spawnErrors : undefined,
+        },
+      };
+    },
+  };
+}
diff --git a/src/tui/tools/bb-spawn-worker.ts b/src/tui/tools/bb-spawn-worker.ts
new file mode 100644
index 0000000..5e90250
--- /dev/null
+++ b/src/tui/tools/bb-spawn-worker.ts
@@ -0,0 +1,168 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { workerSessionManager } from '../../lib/worker-session-manager';
+import { embeddedPiDaemon } from '../../lib/embedded-daemon';
+import { execFileSync } from 'child_process';
+
+/**
+ * Generate a task ID from natural language description.
+ */
+function generateTaskId(description: string): string {
+  const slug = description
+    .toLowerCase()
+    .slice(0, 40)
+    .replace(/[^a-z0-9]+/g, '-')
+    .replace(/^-|-$/g, '');
+  
+  const ts = Date.now().toString(36).slice(-4);
+  return `${slug}-${ts}`;
+}
+
+/**
+ * Create a bead for the worker to work on.
+ * Returns the bead ID.
+ */
+function createBeadForTask(projectRoot: string, title: string, description: string): string {
+  const output = execFileSync('bd', [
+    'create',
+    title,
+    '--description', description,
+    '--type', 'task',
+    '--priority', '2',
+  ], {
+    cwd: projectRoot,
+    encoding: 'utf-8',
+    timeout: 10000,
+  });
+
+  // bd create outputs the bead ID on the last line
+  const beadId = output.trim().split('\n').pop()?.trim();
+  if (!beadId) {
+    throw new Error('Failed to parse bead ID from bd create output');
+  }
+  return beadId;
+}
+
+export function createSpawnWorkerTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_spawn_worker',
+    label: 'Spawn Worker Agent',
+    description: `Spawn an agent to work on a task. Just describe what you want done in natural language.
+
+IMPORTANT: Every worker MUST have a bead to track their work. If no bead_id is provided, one will be created automatically.
+
+Examples:
+- "Review the authentication module for security issues"
+- "Fix the failing test in user-service.test.ts"
+- "Implement the password reset feature"
+- "Debug why the payment webhook is failing"
+
+The agent will:
+1. Claim the bead (status: in_progress)
+2. Work on the task
+3. Update the bead with progress notes
+4. Close the bead when done (with summary)
+
+Check the right panel (Agent Status) to see active agents.`,
+    parameters: Type.Object({
+      description: Type.String({ 
+        description: 'What you want the agent to accomplish. Be specific about files, context, and expected outcome.' 
+      }),
+      agent_type: Type.Optional(Type.String({ 
+        description: 'Agent type: architect (design), engineer (code), reviewer (review), tester (tests), investigator (debug), shipper (deploy). Default: engineer.' 
+      })),
+      bead_id: Type.Optional(Type.String({ 
+        description: 'Optional: existing bead ID to assign this agent to. If not provided, a new bead will be created.' 
+      })),
+    }),
+    async execute(_toolCallId: string, params: unknown): Promise<any> {
+      const { description, agent_type, bead_id: providedBeadId } = params as {
+        description: string;
+        agent_type?: string;
+        bead_id?: string;
+      };
+
+      if (!description || typeof description !== 'string') {
+        return {
+          content: [{ type: 'text', text: 'Please describe what you want the agent to do.' }],
+          isError: true,
+        };
+      }
+
+      // Validate agent type
+      const validAgentTypes = ['architect', 'engineer', 'reviewer', 'tester', 'investigator', 'shipper'];
+      if (agent_type && !validAgentTypes.includes(agent_type)) {
+        return {
+          content: [{ type: 'text', text: `Unknown agent type "${agent_type}". Options: ${validAgentTypes.join(', ')}` }],
+          isError: true,
+        };
+      }
+
+      try {
+        // Step 1: Create a bead if one wasn't provided
+        let beadId = providedBeadId;
+        if (!beadId) {
+          // Use first 60 chars of description as title
+          const title = description.length > 60 
+            ? description.slice(0, 57) + '...'
+            : description;
+          
+          beadId = createBeadForTask(projectRoot, title, description);
+          
+          embeddedPiDaemon.appendEvent(projectRoot, {
+            kind: 'worker.spawned',
+            title: `Created bead: ${beadId}`,
+            detail: title,
+            status: 'launching',
+          });
+        }
+
+        // Step 2: Spawn the worker
+        const worker = await workerSessionManager.spawnWorker({
+          projectRoot,
+          taskId: beadId, // Use bead ID as task ID
+          taskContext: description,
+          agentType: agent_type,
+          beadId, // Pass bead ID to worker
+        });
+
+        const typeMsg = agent_type ? ` (${agent_type})` : '';
+        const beadMsg = providedBeadId 
+          ? `Working on existing bead: ${beadId}`
+          : `Created bead: ${beadId}`;
+        
+        return {
+          content: [{ 
+            type: 'text', 
+            text: `✓ Spawned ${worker.displayName}${typeMsg}
+
+${beadMsg}
+Task: "${description.slice(0, 80)}${description.length > 80 ? '...' : ''}"
+
+The agent will claim this bead, work on it, and close it when done. Watch the right panel for status.` 
+          }],
+          details: {
+            workerId: worker.id,
+            displayName: worker.displayName,
+            beadId,
+            agentType: agent_type || 'engineer',
+          },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        
+        embeddedPiDaemon.appendEvent(projectRoot, {
+          kind: 'worker.failed',
+          title: 'Spawn failed',
+          detail: message,
+          status: 'failed',
+        });
+
+        return {
+          content: [{ type: 'text', text: `Failed to spawn agent: ${message}` }],
+          isError: true,
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-update-agent.ts b/src/tui/tools/bb-update-agent.ts
new file mode 100644
index 0000000..12043d1
--- /dev/null
+++ b/src/tui/tools/bb-update-agent.ts
@@ -0,0 +1,74 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveAgentType, getAgentTypes } from '../../lib/server/beads-fs';
+
+export function createUpdateAgentTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_update_agent',
+    label: 'Update Agent Type',
+    description: 'Update an existing agent type. Provide the ID and fields to update.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Agent type ID to update' }),
+      name: Type.Optional(Type.String({ description: 'New display name' })),
+      description: Type.Optional(Type.String({ description: 'New description' })),
+      systemPrompt: Type.Optional(Type.String({ description: 'New system prompt for workers' })),
+      capabilities: Type.Optional(Type.Array(Type.String(), { description: 'New capabilities list' })),
+      color: Type.Optional(Type.String({ description: 'New hex color' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id, name, description, systemPrompt, capabilities, color } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if agent type exists
+        const agentTypes = await getAgentTypes(projectRoot);
+        const existing = agentTypes.find(a => a.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Agent type "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Merge with existing values
+        const updated = await saveAgentType({
+          id,
+          name: name ?? existing.name,
+          description: description ?? existing.description,
+          systemPrompt: systemPrompt ?? existing.systemPrompt,
+          capabilities: capabilities ?? existing.capabilities,
+          color: color ?? existing.color,
+          isBuiltIn: existing.isBuiltIn,
+        });
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Agent type updated successfully!
+
+ID: ${updated.id}
+Name: ${updated.name}
+Capabilities: ${updated.capabilities.join(', ')}`,
+          }],
+          details: { agentType: updated },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to update agent type: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
diff --git a/src/tui/tools/bb-update-archetype.ts b/src/tui/tools/bb-update-archetype.ts
new file mode 100644
index 0000000..99d1526
--- /dev/null
+++ b/src/tui/tools/bb-update-archetype.ts
@@ -0,0 +1,74 @@
+import { Type } from '@sinclair/typebox';
+import type { ToolDefinition } from '@mariozechner/pi-coding-agent';
+import { saveArchetype, getArchetypes } from '../../lib/server/beads-fs';
+
+export function createUpdateArchetypeTool(projectRoot: string): ToolDefinition {
+  return {
+    name: 'bb_update_archetype',
+    label: 'Update Archetype',
+    description: 'Update an existing archetype. Provide the ID and fields to update. Cannot modify built-in archetypes.',
+    parameters: Type.Object({
+      id: Type.String({ description: 'Archetype ID to update' }),
+      name: Type.Optional(Type.String({ description: 'New display name' })),
+      description: Type.Optional(Type.String({ description: 'New description' })),
+      systemPrompt: Type.Optional(Type.String({ description: 'New system prompt for workers' })),
+      capabilities: Type.Optional(Type.Array(Type.String(), { description: 'New capabilities list' })),
+      color: Type.Optional(Type.String({ description: 'New hex color' })),
+    }),
+    async execute(_toolCallId, params: any) {
+      try {
+        const { id, name, description, systemPrompt, capabilities, color } = params;
+
+        if (!id || typeof id !== 'string') {
+          return {
+            content: [{ type: 'text', text: 'Error: id is required.' }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Check if archetype exists and get current values
+        const archetypes = await getArchetypes();
+        const existing = archetypes.find(a => a.id === id);
+
+        if (!existing) {
+          return {
+            content: [{ type: 'text', text: `Error: Archetype "${id}" not found.` }],
+            isError: true,
+            details: {},
+          };
+        }
+
+        // Merge with existing values
+        const updated = await saveArchetype({
+          id,
+          name: name ?? existing.name,
+          description: description ?? existing.description,
+          systemPrompt: systemPrompt ?? existing.systemPrompt,
+          capabilities: capabilities ?? existing.capabilities,
+          color: color ?? existing.color,
+        });
+
+        return {
+          content: [{
+            type: 'text',
+            text: `Archetype updated successfully!
+
+ID: ${updated.id}
+Name: ${updated.name}
+Description: ${updated.description}
+Capabilities: ${updated.capabilities.join(', ')}`,
+          }],
+          details: { archetype: updated },
+        };
+      } catch (error) {
+        const message = error instanceof Error ? error.message : String(error);
+        return {
+          content: [{ type: 'text', text: `Failed to update archetype: ${message}` }],
+          isError: true,
+          details: { error: message },
+        };
+      }
+    },
+  };
+}
